lcd-bitmap-common.c: Change calculation of the horizontal position in lcd_puts_style_...
[kugel-rb.git] / tools / rockboxdev.sh
bloba3bacce9ee6aa59c45bf4f5585dffe7b262b118e
1 #!/bin/sh
3 # Abort execution as soon as an error is encountered
4 # That way the script do not let the user think the process completed correctly
5 # and leave the opportunity to fix the problem and restart compilation where
6 # it stopped
7 set -e
9 # this is where this script will store downloaded files and check for already
10 # downloaded files
11 dlwhere="${RBDEV_DOWNLOAD:-/tmp/rbdev-dl}"
13 # will append the target string to the prefix dir mentioned here
14 # Note that the user running this script must be able to do make install in
15 # this given prefix directory. Also make sure that this given root dir
16 # exists.
17 prefix="${RBDEV_PREFIX:-/usr/local}"
19 # This directory is used to extract all files and to build everything in. It
20 # must not exist before this script is invoked (as a security measure).
21 builddir="${RBDEV_BUILD:-/tmp/rbdev-build}"
23 # This script needs to use GNU Make. On Linux systems, GNU Make is invoked
24 # by running the "make" command, on most BSD systems, GNU Make is invoked
25 # by running the "gmake" command. Set the "make" variable accordingly.
26 if [ -f "`which gmake 2>/dev/null`" ]; then
27 make="gmake"
28 else
29 make="make"
32 if [ -z $GNU_MIRROR ] ; then
33 GNU_MIRROR=ftp://ftp.gnu.org/pub/gnu
36 # If detection fails, override the value of make manually:
37 # make="make"
39 ##############################################################################
42 # These are the tools this script requires and depends upon.
43 reqtools="gcc bzip2 make patch"
46 findtool(){
47 file="$1"
49 IFS=":"
50 for path in $PATH
52 # echo "Checks for $file in $path" >&2
53 if test -f "$path/$file"; then
54 echo "$path/$file"
55 return
57 done
60 input() {
61 read response
62 echo $response
65 #$1 file
66 #$2 URL"root
67 getfile() {
68 tool=`findtool curl`
69 if test -z "$tool"; then
70 tool=`findtool wget`
71 if test -n "$tool"; then
72 # wget download
73 echo "ROCKBOXDEV: Downloading $2/$1 using wget"
74 $tool -O $dlwhere/$1 $2/$1
76 else
77 # curl download
78 echo "ROCKBOXDEV: Downloading $2/$1 using curl"
79 $tool -Lo $dlwhere/$1 $2/$1
82 if [ $? -ne 0 ] ; then
83 echo "ROCKBOXDEV: couldn't download the file!"
84 echo "ROCKBOXDEV: check your internet connection"
85 exit
88 if test -z "$tool"; then
89 echo "ROCKBOXDEV: No downloader tool found!"
90 echo "ROCKBOXDEV: Please install curl or wget and re-run the script"
91 exit
95 for t in $reqtools; do
96 tool=`findtool $t`
97 if test -z "$tool"; then
98 echo "ROCKBOXDEV: \"$t\" is required for this script to work."
99 echo "ROCKBOXDEV: Please install \"$t\" and re-run the script."
100 exit
102 done
104 ###########################################################################
105 # Verify download directory or create it
106 if test -d "$dlwhere"; then
107 if ! test -w "$dlwhere"; then
108 echo "$dlwhere exists, but doesn't seem to be writable for you"
109 exit
111 else
112 mkdir $dlwhere
113 if test $? -ne 0; then
114 echo "$dlwhere is missing and we failed to create it!"
115 exit
117 echo "$dlwhere has been created to store downloads in"
120 echo "Download directory: $dlwhere (set RBDEV_DOWNLOAD to change dir)"
121 echo "Install prefix: $prefix/[target] (set RBDEV_PREFIX to change dir)"
122 echo "Build dir: $builddir (set RBDEV_BUILD to change dir)"
124 ###########################################################################
125 # Verify that the prefix dir exists and that we can write to it,
126 # as otherwise we will hardly be able to install there!
127 if test ! -d $prefix; then
128 echo "ERROR: The installation destination does not exist."
129 echo "Please create it and re-run this script"
130 exit
132 if test ! -w $prefix; then
133 echo "ERROR: This script is set to install in $prefix but has no write permissions for it"
134 echo "Please fix this and re-run this script"
135 exit
140 cleardir () {
141 # $1 is the name of the build dir
142 # $2 is the arch
143 # delete the build dirs and the source dirs
144 echo "Cleaning up build folder"
145 rm -rf $1/build-gcc-$2 $1/build-binu-$2
148 buildone () {
150 arch=$1
151 gccpatch="" # default is no gcc patch
152 gccver="4.0.3" # default gcc version
153 binutils="2.16.1" # The binutils version to use
154 gccconfigure="" #default is nothing added to configure
155 binutilsconf="" #default is nothing added to configure
156 gcctarget="" #default make target
157 gccinstalltarget="install" #default install target
159 system=`uname -s`
160 gccurl="http://www.rockbox.org/gcc"
162 case $arch in
163 [Ss])
164 target="sh-elf"
165 gccpatch="gcc-4.0.3-rockbox-1.diff"
167 [Mm])
168 target="m68k-elf"
169 gccver="3.4.6"
170 case $system in
171 CYGWIN* | Darwin | FreeBSD | Interix)
172 gccpatch="gcc-3.4.6.patch"
174 Linux)
175 machine=`uname -m`
176 case $machine in
177 x86_64)
178 gccpatch="gcc-3.4.6-amd64.patch"
180 esac
184 esac
186 [Aa])
187 target="arm-elf"
188 gccpatch="rockbox-multilibs-arm-elf-gcc-4.0.3_3.diff"
190 [Ee])
191 target="arm-elf-eabi"
192 gccpatch="rockbox-multilibs-noexceptions-arm-elf-eabi-gcc-4.4.2_1.diff"
193 binutilsconf="--disable-werror"
194 gccver="4.4.2"
195 # needed to build a bare-metal gcc-4.4.2
196 gcctarget="all-gcc all-target-libgcc"
197 gccinstalltarget="install-gcc install-target-libgcc"
198 binutils="2.20"
200 [Ii])
201 target="mipsel-elf"
202 gccver="4.1.2"
203 binutils="2.17"
204 gccconfigure="--disable-libssp"
205 binutilsconf="--disable-werror"
206 # necessary to make binutils build on gcc 4.3+
207 case $system in
208 Interix)
209 gccpatch="gcc-4.1.2-interix.diff"
213 esac
216 echo "An unsupported architecture option: $arch"
217 exit
219 esac
221 bindir="$prefix/$target/bin"
222 if test -n $pathadd; then
223 pathadd="$pathadd:$bindir"
224 else
225 pathadd="$bindir"
228 echo ""
229 echo "In case you encounter a slow internet connection, you can use an alternative mirror."
230 echo "A list of other GNU mirrors is available here: http://www.gnu.org/prep/ftp.html"
231 echo ""
232 echo "Usage: GNU_MIRROR=[URL] ./rockboxdev.sh"
233 echo ""
234 echo "Example:"
235 echo "$ GNU_MIRROR=http://mirrors.kernel.org/gnu ./rockboxdev.sh"
236 echo ""
238 if test -f "$dlwhere/binutils-$binutils.tar.bz2"; then
239 echo "binutils $binutils already downloaded"
240 else
241 getfile binutils-$binutils.tar.bz2 $GNU_MIRROR/binutils
244 if test -f "$dlwhere/gcc-core-$gccver.tar.bz2"; then
245 echo "gcc $gccver already downloaded"
246 else
247 getfile gcc-core-$gccver.tar.bz2 $GNU_MIRROR/gcc/gcc-$gccver
250 if test -n "$gccpatch"; then
251 if test -f "$dlwhere/$gccpatch"; then
252 echo "$gccpatch already downloaded"
253 else
254 getfile "$gccpatch" "$gccurl"
258 ###########################################################################
259 # If there's already a build dir, we don't overwrite or delete it
260 if test -d $builddir; then
261 if test ! -w $builddir; then
262 echo "ERROR: No write permissions for the build directory!"
263 exit
265 else
266 mkdir -p $builddir
269 cd $builddir
271 ###########################################################################
272 # Create a summary file for each toolchain, containing info about the version
273 # and a remainder to append the compiler path to PATH
275 summary="summary-$1"
277 echo "============================ Summary ============================" > $summary
278 echo "target: $target" >> $summary
279 echo "gcc version: $gccver" >> $summary
280 if test -n "$gccpatch"; then
281 echo "gcc patch: $gccpatch" >> $summary
283 echo "binutils: $binutils" >> $summary
284 echo "installation target: $prefix/$target" >> $summary
285 echo "" >> $summary
286 echo "When done, append $bindir to PATH" >> $summary
287 echo "=================================================================" >> $summary
289 cat $summary
291 echo "ROCKBOXDEV: extracting binutils-$binutils in $builddir"
292 tar xjf $dlwhere/binutils-$binutils.tar.bz2
293 echo "ROCKBOXDEV: extracting gcc-$gccver in $builddir"
294 tar xjf $dlwhere/gcc-core-$gccver.tar.bz2
296 if test -n "$gccpatch"; then
297 echo "ROCKBOXDEV: applying gcc patch"
298 patch -p0 < "$dlwhere/$gccpatch"
301 echo "ROCKBOXDEV: mkdir build-binu-$1"
302 mkdir build-binu-$1
303 echo "ROCKBOXDEV: cd build-binu-$1"
304 cd build-binu-$1
305 echo "ROCKBOXDEV: binutils/configure"
306 # we undefine _FORTIFY_SOURCE to make the binutils built run fine on recent
307 # Ubuntu installations
308 CFLAGS=-U_FORTIFY_SOURCE ../binutils-$binutils/configure --target=$target --prefix=$prefix/$target $binutilsconf
309 echo "ROCKBOXDEV: binutils/make"
310 # We add -r when building binutils to fix compilation on OSX - Apple's make has
311 # extra built-ins which cause problems.
312 $make -r
313 echo "ROCKBOXDEV: binutils/make install to $prefix/$target"
314 $make install
315 cd .. # get out of build-binu-$1
316 PATH="$bindir:${PATH}"
317 SHELL=/bin/sh # seems to be needed by the gcc build in some cases
319 echo "ROCKBOXDEV: mkdir build-gcc-$1"
320 mkdir build-gcc-$1
321 echo "ROCKBOXDEV: cd build-gcc-$1"
322 cd build-gcc-$1
323 echo "ROCKBOXDEV: gcc/configure"
324 # we undefine _FORTIFY_SOURCE to make the gcc build go through fine on
325 # recent Ubuntu installations
326 CFLAGS=-U_FORTIFY_SOURCE ../gcc-$gccver/configure --target=$target --prefix=$prefix/$target --enable-languages=c $gccconfigure
327 echo "ROCKBOXDEV: gcc/make"
328 $make $gcctarget
329 echo "ROCKBOXDEV: gcc/make install to $prefix/$target"
330 $make $gccinstalltarget
331 cd .. # get out of build-gcc
332 cd .. # get out of $builddir
334 } # buildone()
336 echo ""
337 echo "Select target arch:"
338 echo "s - sh (Archos models)"
339 echo "m - m68k (iriver h1x0/h3x0, ifp7x0 and iaudio)"
340 echo "a - arm (ipods, iriver H10, Sansa, etc)"
341 echo "e - arm-eabi (same as above, new testing toolchain)"
342 echo "i - mips (Jz4740 and ATJ-based players)"
343 echo "separate multiple targets with spaces"
344 echo "(Example: \"s m a\" will build sh, m86k and arm)"
345 echo ""
347 selarch=`input`
349 for arch in $selarch
351 echo ""
352 case $arch in
353 [Ss])
354 buildone $arch
355 cleardir $builddir $arch
357 [Ii])
358 buildone $arch
359 cleardir $builddir $arch
361 [Mm])
362 buildone $arch
363 cleardir $builddir $arch
365 [Aa])
366 buildone $arch
367 cleardir $builddir $arch
369 [Ee])
370 buildone $arch
371 cleardir $builddir $arch
374 echo "An unsupported architecture option: $arch"
375 exit
377 esac
378 done
380 # show the summaries:
381 cat $builddir/summary-*
382 rm $builddir/summary-*
384 echo ""
385 echo "Done!"
386 echo ""
387 echo "Make your PATH include $pathadd"
388 echo ""